"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RelativePathsSlsPlugin = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _path = require("path");

var servicePropertiesSchema = {
  type: 'object',
  properties: {
    "default": {
      type: 'string'
    }
  },
  additionalProperties: false
};
var fnPropertiesSchema = {
  type: 'object',
  properties: {
    dirName: {
      type: 'string'
    }
  },
  required: ['dirName'],
  additionalProperties: false
};
var RelativePathsSlsPlugin = /*#__PURE__*/(0, _createClass2["default"])(function RelativePathsSlsPlugin(serverless) {
  (0, _classCallCheck2["default"])(this, RelativePathsSlsPlugin);
  serverless.configSchemaHandler.defineTopLevelProperty('relativePaths', servicePropertiesSchema);
  serverless.configSchemaHandler.defineFunctionProperties('aws', fnPropertiesSchema);
  this.hooks = {
    initialize: function initialize() {
      var _serverless$configura;

      var rootDirName = serverless.config.servicePath;
      var defaultRelativePath = (_serverless$configura = serverless.configurationInput.relativePaths) === null || _serverless$configura === void 0 ? void 0 : _serverless$configura["default"];
      Object.entries(serverless.service.functions).forEach(function (_ref) {
        var _ref4;

        var _ref2 = (0, _slicedToArray2["default"])(_ref, 2),
            functionName = _ref2[0],
            functionDefinition = _ref2[1];

        var _ref3 = functionDefinition,
            fnDirName = _ref3.dirName,
            handler = _ref3.handler;
        var appliedRelativePath = (_ref4 = handler) !== null && _ref4 !== void 0 ? _ref4 : defaultRelativePath;

        if (typeof appliedRelativePath !== 'string') {
          throw new serverless.classes.Error("No relative path found for function ".concat(functionName, "\n\nLearn more on https://github.com/ThomasAribart/sls-relative-paths"), 'INVALID_PLUGIN_INPUT');
        }

        var functionRef = serverless.service.functions[functionName];
        functionRef.handler = (0, _path.join)((0, _path.relative)(rootDirName, fnDirName), appliedRelativePath.replace(/\//g, _path.sep)).split(_path.sep).join('/'); // @ts-expect-error Property no longer needed

        delete functionRef.dirName;
      });
    }
  };
});
exports.RelativePathsSlsPlugin = RelativePathsSlsPlugin;
//# sourceMappingURL=plugin.js.map