import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _createClass from "@babel/runtime/helpers/createClass";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import { join, relative, sep } from 'path';
var servicePropertiesSchema = {
  type: 'object',
  properties: {
    "default": {
      type: 'string'
    }
  },
  additionalProperties: false
};
var fnPropertiesSchema = {
  type: 'object',
  properties: {
    dirName: {
      type: 'string'
    }
  },
  required: ['dirName'],
  additionalProperties: false
};
export var RelativePathsSlsPlugin = /*#__PURE__*/_createClass(function RelativePathsSlsPlugin(serverless) {
  _classCallCheck(this, RelativePathsSlsPlugin);

  serverless.configSchemaHandler.defineTopLevelProperty('relativePaths', servicePropertiesSchema);
  serverless.configSchemaHandler.defineFunctionProperties('aws', fnPropertiesSchema);
  this.hooks = {
    initialize: function initialize() {
      var _serverless$configura;

      var rootDirName = serverless.config.servicePath;
      var defaultRelativePath = (_serverless$configura = serverless.configurationInput.relativePaths) === null || _serverless$configura === void 0 ? void 0 : _serverless$configura["default"];
      Object.entries(serverless.service.functions).forEach(function (_ref) {
        var _ref4;

        var _ref2 = _slicedToArray(_ref, 2),
            functionName = _ref2[0],
            functionDefinition = _ref2[1];

        var _ref3 = functionDefinition,
            fnDirName = _ref3.dirName,
            handler = _ref3.handler;
        var appliedRelativePath = (_ref4 = handler) !== null && _ref4 !== void 0 ? _ref4 : defaultRelativePath;

        if (typeof appliedRelativePath !== 'string') {
          throw new serverless.classes.Error("No relative path found for function ".concat(functionName, "\n\nLearn more on https://github.com/ThomasAribart/sls-relative-paths"), 'INVALID_PLUGIN_INPUT');
        }

        var functionRef = serverless.service.functions[functionName];
        functionRef.handler = join(relative(rootDirName, fnDirName), appliedRelativePath.replace(/\//g, sep)).split(sep).join('/'); // @ts-expect-error Property no longer needed

        delete functionRef.dirName;
      });
    }
  };
});
//# sourceMappingURL=plugin.js.map